#include "ghostinfo.h"
#include <cstring>


// 񂩂󔒂ăRs[
// K蓮delete邱
char* ClearSpace(const char* str){
  if(!str) return 0;
  char* newStr = new char[strlen(str)+1];
  
  int i = 0;           // Rs[JEg
  while(*str != '\0'){ // 󔒂
    if(*str != ' ') newStr[i++] = *str;
    ++str;
  }
  newStr[i] = '\0';
  return newStr;
}


// T[tBXnbV}bvɒǉ
void GhostInfo::AddSurface(int surfaceID, const char* sprite){
  if(!sprite) return;
  char* spriteStr = ClearSpace(sprite); // XvCgw肷镶񂩂󔒂
  
  char* spriteEndptr;
  int spriteID = strtol(spriteStr, &spriteEndptr, 10);
  
  // XvCgIDŒ(x:y̌`)
  if(*spriteEndptr == '\0') AddSurface(surfaceID, spriteID);
  
  // XvCgID̓T[tBXIDƓ(x:*̌`)
  else if(spriteStr[0] == '*') AddSurface(surfaceID, surfaceID); 
  
  // ÕubNŎw肵ĂXvCgID+1XvCgID(x:+̌`)
  else if(spriteStr[0] == '+') AddSurface(surfaceID, prevSpriteID+1);
  
  // *+ł̎wȊOŐlɕϊs\ȏꍇAϊ\ȕ܂œǂݍ
  else AddSurface(surfaceID, spriteID);
  
  delete[] spriteStr;
}



// T[tBXnbV}bvɒǉ
void GhostInfo::AddSurface(const char* surface, const char* sprite){
  if(!surface) return;
  char* surfaceStr = ClearSpace(surface); // T[tBXw肷镶񂩂󔒂
  
  char* surfaceEndptr;
  int surfaceID = strtol(surfaceStr, &surfaceEndptr, 10);
  
  if(*surfaceEndptr == '\0'){ // T[tBXw蕔̂
    AddSurface(surfaceID, sprite);
  }
  else{
    char* right = strchr(surfaceEndptr, '-');
    if(right){ // T[tBXw蕔x-y̌`
      ++right; // |C^y̐擪Ɉړ
      char* rightEndptr;
      int rightID = strtol(right, &rightEndptr, 10);
      // xy܂łǂݍ݁Alɕϊs\ȕ͖
      for(; surfaceID <= rightID; ++surfaceID) AddSurface(surfaceID, sprite);
    }
    // -ł̎wȊOŐlɕϊs\ȏꍇAϊ\ȕ܂œǂݍ
    else AddSurface(surfaceID, sprite);
  }
  
  delete[] surfaceStr;
}


int GhostInfo::WriteImage(int surfaceID, HBITMAP hBitmap) const{
  SurfaceMap::const_iterator surfaceItr = surfaceMap.find(surfaceID);
  if(surfaceItr == surfaceMap.end()) return 1; // ݂ȂT[tBX
  
  return surface.WriteImage(surfaceID, surfaceItr->second, hBitmap);
}

