#include "text.h"
#include <cstdio>
#include <cstring>



// t@CTCYZo
unsigned long FileSize(const char* fileName){
  HANDLE handle = CreateFile(fileName, GENERIC_READ, FILE_SHARE_READ, 0,
                             OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
  if(handle == INVALID_HANDLE_VALUE) return 0; // t@CJĂȂ(̏ꍇCloseHandle͕sv)
  unsigned long ret = GetFileSize(handle, 0);
  CloseHandle(handle);
  return ret;
}



// t@CŜxɓǂݍ݁AIɏ
Text::Text(const char* fileName){
  unsigned long fileSize = FileSize(fileName);
  FILE* fp = fopen(fileName, "r");
  if(fp == 0 || fileSize == INVALID_FILE_SIZE){
    txt = 0;
  }
  else{
    txt = new char[fileSize+1];
    unsigned long textSize = fread(txt, 1, fileSize, fp);     // OɃt@CTCY𒲂ׁATCYxɓǂݍ
    if(ferror(fp) != 0 || textSize > fileSize){               // t@Cǂ߂Ȃ͓ǂݍ񂾃TCY
      delete[] txt;
      txt = 0;
    }
    else txt[textSize] = '\0';                                // ƂĈ̂\0𖖔ɉ
  }
  if(fp) fclose(fp);
}



// ImۂRs[
// K蓮delete邱
// sꍇ0Ԃ
char* NewString(const char* str){
  if(!str) return 0;
  char* ret = new char[strlen(str) + 1]; // ̒+\0̕m
  return strcpy(ret, str);
}



// str1str2qēIɊmۂɊi[
// K蓮delete邱
// sꍇ0Ԃ
char* Combine(const char* str1, const char* str2){
  if(!str1 || !str2) return 0;
  char* str = new char[strlen(str1) + strlen(str2) + 1];
  strcpy(str, str1);
  return strcat(str, str2);
}



// ̃bZ[Wqĕ\
void CombinedMessage(const char* msg1, const char* msg2){
  const char* msg = Combine(msg1, msg2);
  Message(msg);
  delete[] msg;
}



// tpX̃t@ĈݕύX쐬
// K蓮delete邱
// sꍇ0Ԃ
char* ChangeFileNameOfFullPath(const char* path, const char* newFileName){
  char* dir = NewString(path);                   // tpXRs[
  if(!dir) return 0;                             // tpXRs[łĂȂ
  char* separator = strrchr(dir, '\\');          // Ō\̈ʒu
  if(!separator) return 0;                       // \Ȃ
  *(separator+1) = '\0';                         // Ō\Ő؂
  char* newFullPath = Combine(dir, newFileName); // A
  delete[] dir;
  return newFullPath;
}



